#!/usr/bin/perl -w

use File::Temp;
use File::Path;

use strict;

my @files = qw(
http://www.ctan.org/get/macros/latex/contrib/hyperref.zip
ftp://tug.ctan.org/pub/tex-archive/macros/generic/ifxetex.zip
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/atbegshi.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/bigintcalc.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/bitset.dtx 
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/etexcmds.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/hycolor.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/infwarerr.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/intcalc.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/kvoptions.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/kvsetkeys.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/pdftexcmds.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/ifpdf.dtx
ftp://ftp.ctan.org/tex-archive/macros/latex/contrib/oberdiek/ifvtex.dtx
);

my $home_tex = $ENV{"HOME"} . "/texmf";
my $oberdiek = $home_tex . "/tex/latex/oberdiek";
my $hyperref = $home_tex . "/tex/latex/hyperref";
my $ifxetex = $home_tex . "/tex/latex/ifxetex";

my $tmpdir = File::Temp->tempdir("tmp-XXXX");
my $i;
my $file;
my $fetch = "fetch";
my @fields;

# prepare
unless (-e $home_tex) {
	mkdir($home_tex) || die "Cannot make $home_tex";
}

unless (-e $oberdiek) {
	eval { mkpath($oberdiek) };
	if ($@) {
		print "Cannot make $oberdiek: $@";
	}
}

unless (-e $hyperref) {
	eval { mkpath($hyperref) };
	if ($@) {
		print "Cannot make $hyperref: $@";
	}
}

unless (-e $ifxetex) {
	eval { mkpath($ifxetex) };
	if ($@) {
		print "Cannot make $ifxetex: $@";
	}
}

chdir($tmpdir) || die "Cannot change to $tmpdir"; 

# fetch
foreach $i (@files) {
	system("$fetch $i"); 

	@fields = split(/\//, $i);
	$file = pop(@fields);
	print $file;
	unless (-e $file) {
		die "Cannot find $file";
	}
}

foreach $i (@files) {
	@fields = split(/\//, $i);
	$file = pop(@fields);
	if ($file =~ "hyperref.zip") {
		system("unzip $file");
		chdir($tmpdir . "/hyperref") || die "Cannot change dir to hyperref";
		system("tex hyperref.ins");
		system("cp *.sty *.def *.cfg $hyperref");
		chdir($tmpdir) || die "Cannot change dir to $tmpdir";
	} elsif ($file =~ "ifxetex.zip") {
		system("unzip $file");
		chdir($tmpdir . "/ifxetex") || die "Cannot change dir to ifxetex";
		system("latex ifxetex.ins");
		system("cp *.sty $ifxetex");
		chdir($tmpdir) || die "Canno change dir to $tmpdir"; 
	} else {
		system("tex $file");
	}
}

system("cp *.sty $oberdiek");

chdir($ENV{"HOME"});
system("rm -rf $tmpdir");

system("texhash");
